import { Maybe } from '../utils/types';
import { RefObject } from 'react';
import { GlobalStyle, Style } from './style';
export declare type Store = {
    rules: {
        style: Style;
        context?: {
            target?: RefObject<HTMLElement>;
        };
    }[];
    globalStyle: GlobalStyle;
    cursor: Maybe<HTMLElement>;
};
declare const Provider: ({ children }: {
    children: import("react").ReactNode;
}) => JSX.Element, useStore: {
    (): Store;
    <SelectorOutput>(selector: (store: Store) => SelectorOutput): SelectorOutput;
}, useStoreDispatch: {
    (): (payload: Partial<Store> | ((previousValue: Partial<Store>) => Partial<Store>)) => void;
    <Key extends keyof Store>(key: Key): (payload: Store[Key] extends infer T ? T extends Store[Key] ? T extends Function ? never : T | ((previousValue: T) => T) : never : never) => void;
}, getState: () => Store, subscribe: (callback: (state: Store) => void) => () => boolean;
export declare const setGlobalStyle: (property: GlobalStyle | ((previousValue: GlobalStyle) => GlobalStyle)) => void;
export declare const setRules: (property: {
    style: Style;
    context?: {
        target?: RefObject<HTMLElement> | undefined;
    } | undefined;
}[] | ((previousValue: {
    style: Style;
    context?: {
        target?: RefObject<HTMLElement> | undefined;
    } | undefined;
}[]) => {
    style: Style;
    context?: {
        target?: RefObject<HTMLElement> | undefined;
    } | undefined;
}[])) => void;
export declare const setCursor: (property: HTMLElement | ((previousValue: undefined) => undefined) | ((previousValue: null) => null) | ((previousValue: HTMLElement) => HTMLElement) | null | undefined) => void;
export { Provider, useStore, useStoreDispatch, getState, subscribe };
