import { Maybe } from '../utils/types';
import { CSSProperties, RefObject } from 'react';
import { Effect } from './effects';
import { Shape } from './shapes';
export declare const defaultCursorStyles: CSSProperties;
export declare type GlobalStyle = {
    color: NonNullable<CSSProperties['color']>;
    height: NonNullable<CSSProperties['height']>;
    width: NonNullable<CSSProperties['width']>;
};
interface StyleProps<T extends HTMLElement> extends GlobalStyle {
    cursor?: Maybe<HTMLElement>;
    target?: RefObject<T>;
}
export declare type Style<T extends HTMLElement = HTMLElement> = CSSProperties | ((sharedStyle: StyleProps<T>) => CSSProperties);
declare type ComputeStyleProps<T extends HTMLElement> = {
    style?: Style<T>;
    globalStyle: GlobalStyle;
    target?: RefObject<T>;
    cursor?: Maybe<HTMLElement>;
};
export declare function computeStyle<T extends HTMLElement>({ style, globalStyle, target, cursor, }: ComputeStyleProps<T>): CSSProperties;
export declare type EffectStyles = `Effect.${Effect}`;
export declare type ShapeStyles = `Shape.${Shape}`;
export declare type CursorStylePayload = Style | EffectStyles | ShapeStyles;
export declare function getStyleFromPayload<T extends HTMLElement>(target?: RefObject<T>): (payload: CursorStylePayload) => {
    style: Style;
    context?: {
        target?: RefObject<T>;
    };
};
export {};
