/**
 * This function allow us to use a pubsub store
 * preventing the reload of the whole app even
 * if the provider is used at the root level
 * https://www.youtube.com/watch?v=ZKlXqrcBx88
 * https://github.com/jherr/fast-react-context
 */
import { ReactNode } from 'react';
export declare function createPubSubContext<State>(initialState: State, name: string): Readonly<{
    Provider: ({ children }: {
        children: ReactNode;
    }) => JSX.Element;
    useStore: {
        (): State;
        <SelectorOutput>(selector: (store: State) => SelectorOutput): SelectorOutput;
    };
    useStoreDispatch: {
        (): (payload: Partial<State> extends infer T ? T extends Partial<State> ? T extends Function ? never : T | ((previousValue: T) => T) : never : never) => void;
        <Key extends keyof State>(key: Key): (payload: State[Key] extends infer T_1 ? T_1 extends State[Key] ? T_1 extends Function ? never : T_1 | ((previousValue: T_1) => T_1) : never : never) => void;
    };
    getState: () => State;
    setState: {
        (state: Partial<State> extends infer T ? T extends Partial<State> ? T extends Function ? never : T | ((previousValue: T) => T) : never : never): void;
        <Key_1 extends keyof State>(key: Key_1, property: State[Key_1] extends infer T_2 ? T_2 extends State[Key_1] ? T_2 extends Function ? never : T_2 | ((previousValue: T_2) => T_2) : never : never): void;
    };
    subscribe(callback: (state: State) => void): () => boolean;
}>;
