export declare function createPubSubStore<State>(initialState: State): Readonly<{
    get(): State;
    set(payload: Partial<State> extends infer T ? T extends Partial<State> ? T extends Function ? never : T | ((previousValue: State) => T) : never : never): void;
    setProperty<Key extends keyof State, Property = State[Key]>(key: Key, payload: Property extends Function ? never : Property | ((previousValue: Property) => Property)): void;
    subscribe(callback: () => void): () => boolean;
}>;
